Bug 213578 - Adding Experimental Feature Flags for CoreImage backed SVG/CSS Filters
Summary: Adding Experimental Feature Flags for CoreImage backed SVG/CSS Filters
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: CSS (show other bugs)
Version: Other
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: guowei_yang
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2020-06-24 15:32 PDT by guowei_yang
Modified: 2020-06-30 09:30 PDT (History)
22 users (show)

See Also:


Attachments
Patch (53.57 KB, patch)
2020-06-24 16:10 PDT, guowei_yang
no flags Details | Formatted Diff | Diff
Patch (6.57 KB, patch)
2020-06-24 21:16 PDT, guowei_yang
no flags Details | Formatted Diff | Diff
Patch (6.58 KB, patch)
2020-06-24 21:34 PDT, guowei_yang
no flags Details | Formatted Diff | Diff
Patch (6.70 KB, patch)
2020-06-25 16:33 PDT, guowei_yang
no flags Details | Formatted Diff | Diff
Patch (6.80 KB, patch)
2020-06-26 13:09 PDT, guowei_yang
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description guowei_yang 2020-06-24 15:32:18 PDT
Starting to implement CSS filters using CoreImage to accelerate. This patch contains the necessary building blocks that guards new implementations using a feature flag.
Comment 1 Radar WebKit Bug Importer 2020-06-24 15:33:14 PDT
<rdar://problem/64724629>
Comment 2 guowei_yang 2020-06-24 16:10:34 PDT
Created attachment 402693 [details]
Patch
Comment 3 Darin Adler 2020-06-24 17:19:06 PDT
Comment on attachment 402693 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=402693&action=review

> Source/JavaScriptCore/Configurations/FeatureDefines.xcconfig:338
> +ENABLE_ACCELERATED_FILTER_RENDER = ENABLE_ACCELERATED_FILTER_RENDER;

There is no need to add new features to FeatureDefines.xcconfig. Just put them in PlatformEnableCocoa.h instead.
Comment 4 Darin Adler 2020-06-24 17:19:07 PDT
Comment on attachment 402693 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=402693&action=review

> Source/JavaScriptCore/Configurations/FeatureDefines.xcconfig:338
> +ENABLE_ACCELERATED_FILTER_RENDER = ENABLE_ACCELERATED_FILTER_RENDER;

There is no need to add new features to FeatureDefines.xcconfig. Just put them in PlatformEnableCocoa.h instead.
Comment 5 Myles C. Maxfield 2020-06-24 21:09:13 PDT
Comment on attachment 402693 [details]
Patch

red red red red red red red red red red red red red red red red red red red
Comment 6 guowei_yang 2020-06-24 21:16:13 PDT
Created attachment 402714 [details]
Patch
Comment 7 Simon Fraser (smfr) 2020-06-24 21:20:53 PDT
Comment on attachment 402714 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=402714&action=review

> Source/WTF/wtf/PlatformUse.h:62
> +#define USE_CI 1

Please call this USE_CORE_IMAGE. CI is very ambiguous.
Comment 8 guowei_yang 2020-06-24 21:34:26 PDT
Created attachment 402715 [details]
Patch
Comment 9 Darin Adler 2020-06-25 10:05:45 PDT
Comment on attachment 402715 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=402715&action=review

Looks OK

> Source/WTF/wtf/PlatformUse.h:63
> +#if PLATFORM(COCOA)
> +#define USE_CORE_IMAGE 1
> +#endif

There’s already CoreImage usage in WebKit. I’m not sure how we’re going to use this going forward, and if maybe we should be using it on existing code instead of what it’s currently doing?
Comment 10 guowei_yang 2020-06-25 16:33:16 PDT
Created attachment 402827 [details]
Patch
Comment 11 guowei_yang 2020-06-26 13:09:39 PDT
Created attachment 402892 [details]
Patch
Comment 12 EWS 2020-06-29 18:59:33 PDT
Committed r263718: <https://trac.webkit.org/changeset/263718>

All reviewed patches have been landed. Closing bug and clearing flags on attachment 402892 [details].
Comment 13 Simon Fraser (smfr) 2020-06-30 09:30:54 PDT
Comment on attachment 402892 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=402892&action=review

> Source/WebKit/Shared/WebPreferences.yaml:2049
> +CoreImageAcceleratedFilterRenderEnabled:

I would have called this CoreImageAcceleratedFilterRenderingEnabled or CoreImageAcceleratedFiltersEnabled